﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using Arction.WPF.LightningChartUltimate;
using Arction.WPF.LightningChartUltimate.Annotations;
using Arction.WPF.LightningChartUltimate.SeriesXY;
using Arction.WPF.LightningChartUltimate.Axes;
using Arction.WPF.LightningChartUltimate.Views.ViewXY;

using System.Threading;
using System.Diagnostics;

namespace speed2d
{
    /// <summary>
    /// Логика взаимодействия для MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        IntensityGridSeries chartData = null;

        public MainWindow()
        {
            InitializeComponent();

            chart1.BeginUpdate();

            chart1.ActiveView = ActiveView.ViewXY;
            chart1.ViewXY.XAxes[0].ValueType = AxisValueType.Number;
            chart1.ViewXY.YAxes[0].ValueType = AxisValueType.Number;
            chart1.ViewXY.XAxes[0].SetRange(0, 1088);
            chart1.ViewXY.YAxes[0].SetRange(0, 1024);
            chart1.ViewXY.LegendBox.Visible = false;

            chartData = new IntensityGridSeries(chart1.ViewXY, chart1.ViewXY.XAxes[0], chart1.ViewXY.YAxes[0]);
            chartData.SetSize(1088, 1024);
            chartData.SetRangesXY(0, 1088, 0, 1024);            
            chartData.MouseInteraction = false;
            chartData.Optimization = IntensitySeriesOptimization.DynamicValuesData;
            chartData.ShowNodes = false;
            chartData.PixelRendering = true;

            chart1.ViewXY.IntensityGridSeries.Add(chartData);

            // Set geometry
            for (int i = 0; i < chartData.SizeY; i++)
            {
                for (int j = 0; j < chartData.SizeX; j++)
                {
                    chartData.Data[j, i].X = i;
                    chartData.Data[j, i].Y = j;
                }
            }

            dd = new double[chartData.SizeY][];
            pixels = new int[chartData.SizeY][];

            for (int i = 0; i < chartData.SizeY; i++)
            {
                dd[i] = new double[chartData.SizeX];
                pixels[i] = new int[chartData.SizeX];
            }

            chart1.EndUpdate();


            System.Windows.Threading.DispatcherTimer ttm = new System.Windows.Threading.DispatcherTimer();
            ttm.Interval = new TimeSpan(0, 0, 0, 0, 500);
            ttm.Tick += new EventHandler(Update);
            ttm.Start();
        }

        double[][] dd = null;
        int[][] pixels = null;

        void Update(object sender, EventArgs e)
        {
            Random rnd = new Random();

            st.Restart();

            // Fill with random data
            for (int i = 0; i < chartData.SizeY; i++)
            {
                for (int j = 0; j < chartData.SizeX; j++)
                {
                    dd[i][j] = rnd.NextDouble() * 255.0;
                    pixels[i][j] = 255 << 24 | (rnd.Next() % 255) << 16 | (rnd.Next() % 255) << 8 | (rnd.Next() % 255);
                }
            }

            st.Stop();

            // doesn't matter
            wnd.Title = "";// "Prepare data: " + st.ElapsedMilliseconds.ToString() + " ms. ";

            st.Restart();

            chart1.BeginUpdate();

            // Veriant 1: SetValuesData, redraw time is about 22ms
            chartData.Fill = IntensityFillStyle.Paletted;
            chartData.SetValuesData(dd, IntensityGridValuesDataOrder.RowsColumns);

            // Veriant 2: SetColorsData, redraw time is about 45ms
            //chartData.Fill = IntensityFillStyle.FromSurfacePoints;
            //chartData.SetColorsData(pixels, IntensityGridValuesDataOrder.RowsColumns);

            chartData.InvalidateValuesDataOnly();
            
            chart1.EndUpdate();

            st.Stop();

            wnd.Title += "Redraw: " + st.ElapsedMilliseconds.ToString() + " ms";
        }

        Stopwatch st = new Stopwatch();
    }
}
